// vous devez placer le fichier de mesure dans le répertoire de travail.
//-------------Ouverture et lecture du fichier csv ---------------------------------
// la commande csvRead(...)  permet l'import de donnéès au format csv 
// M = csvRead(noMFichier, séparateur, decimal, conversion, substitution, regexpcomments, zoneAImporter, entete)
// seul le nom du fichier est obligatoire

getd()// chargement de la librairie de fonctions
nomFichier="signal.csv"
// Mesure=csvRead(nomFichier)
separateur=";" // il faut parfois préciser le séparateur, ici ";"
decimal=[","] // deux valeurs possibles  par défaut[], le point est le séparateur décimal, ici ".", si non vide et l'item suivant conversion=["string"], alors conversion en chaîne de caractères
// Tester les  commandes suivantes dans la console,
// Mesure=csvRead(nomFichier,separateur)
// Mesure=csvRead(nomFichier,separateur,decimal)
// Mesure=csvRead("signal.cvs,[";"],[","])
// Mesure=csvRead("signal.csv",';',[],[],["," "."])
// zoneaExtraire=[2 1 10 2]
// Extrait=csvRead(nomFichier,separateur,decimal,[],[],[], zoneaExtraire)
// taille=size(Mesure)
// La commande csvRead permet normalement de supprimer l'entete mais ici, il semble il y avoir un bug!!
// ??? Que peut-on dire de la variable Mesure ???
Mesure=csvRead(nomFichier,separateur,decimal) // 

taille=size(Mesure)//la commande  size() permet d'obtenir les dimensions d'un tableau
//disp(taille)// la commande disp()  permet l'affichage dans la console d'un texte ou d'une variable, elle a un comportement assez bizarre, il est préférable de construire avant la chaine de caractère que l'on souhaite afficher
TexteaAfficher=string(taille(1))+"lignes et "+string(taille(2))+" colonnes"
disp(TexteaAfficher)
// ??? que font les commandes string(), taille(1), taille(2)???
// Tester les commandes suivantes dans la console

// Mesure(1,:)
// Mesure(10,:)
// Mesure(:,1)
// Mesure(:,2)
// Mesure($)
// A=Mesure(200:203,1:2) //???Que peut-on dire de A???

//----------- Les matrices------------
// Nous allons tester quelques opérations et fonctions sur les matrices (à faire dans la console)

// 3*A
// A+A
// A'    //Attention à l'apostrophe! ??? Que fait cette opérateur?
// A*A
// A.*A   // Attention au point
// B=A*A'
 
// det(B)
// trace(B)
//spec(B)
//[X matriceVecteurPropre]=spec(B)

// Scilab est fortement orienté calcul matriciel, c'est une grosse différence avec d'autres langages
// On appelle temps, la variable tableau correspondant à la première colonne du fichier signaL.csv  et mesuresBrutes, la deusième colonnes
// Ecrire le script qui permet d'obtenir ces deux variables

temps=Mesure(2:2562,1);
mesuresBrutes=Mesure(2:2562,2);
// -----------------------Affichage des courbes------------------------------
// tester les commandes suivantes
// plot(temps,mesuresBrutes)
clf
plot(temps,mesuresBrutes)
legend("Mesures brutes")
// ------------------------Filtre----------------------------------------
// le signal est fortement bruité, on se propose, avant de l'analyser, le filtre afin d'atténuer le bruit.

// ----------------- Filtre du premier ordre ---------------------------------
// Un filtre du premier ordre est un filtre qui répond à l'équation différentielle suivante:
// S_f(t) + tau*d/dt(S_f(t)=K*e(t)
// avec S_f(t) la sortie filtrée, e(t) l'entrée, tau la constante de temps du filtre et K le gain (ici K=1)
// cette équation peut s'écrire pour une acquisition discrère avec une période d'échantillonage Te
s_filtree=filtre(mesuresBrutes, 0.05, 0.5)
clf
subplot(231)
plot2d(temps,mesuresBrutes)
legend(["mesures brutes"])
title("acquisition capteur")
 xlabel("temps:s")
ylabel("mesure")
s_f=Sinfiny(s_filtree)

subplot(232)
plot2d(temps,[mesuresBrutes,s_filtree],style=[3,5])
plot2d([temps(1),temps($)},[s_f,s_f])
legend(["mesures brutes", "filtrées"],4)
title("mesure et signal filtré")
 xlabel("temps:s")
ylabel("mesure")
//clf
s_log=Slog(s_filtree)
[n_ele, c]=size(s_log)
t=temps(1:n_ele)
[a,b]=regression(t,s_log)
subplot(233)
plot2d(t,[s_log,a*t+b])
legende1="$\log(s_\infty-s(t))$"
legende2="$a\cdot t + b$"
format(5)
tta=string(-1/a)
ttb=string(b)
textetau="$\tau=-\frac{1}{a}=$"
texte1=textetau
xstring(0.1,-0.4,texte1)
xstring(0.5,-0.4,tta)
texte2="b="+ttb
xstring(0.1,-0.6,texte2)
legend([legende1,legende2])
tt_tau="$\tau$"
tt_titre="détermination de"+ tt_tau
title(tt_titre)
 xlabel(legende1)
ylabel("y")

subplot(234)
t2=temps(1:800)
t800=t2($)
modele=s_f*(1-exp(a*t2))
tau=-1/a
plot(t2,[s_filtree(1:800), modele],style=[3,5])
plot([0, t800], [0.95*s_f,.95*s_f])
plot([0, t800], [s_f,s_f],style=[5])
plot([0, t800], [1.05*s_f,1.05*s_f])
plot([3*tau,3*tau],[0,0.95*s_f])
plot([0,tau,tau],[0,s_f,0])
title("modèle 1er ordre et signal filtré")
 xlabel("temps:s")
ylabel("mesure")
subplot(235)
modele=s_f*(1-exp(a*temps))
[a2,b2]=regression(modele,[s_filtree])
plot(modele,[s_filtree,a2*modele+b2])
title("Corelation  signal filtré / modèle")
 xlabel("s_filtree(t)")
ylabel("modèle")
subplot(236)
modele=s_f*(1-exp(a*temps))
[a3,b3]=regression(modele,[mesuresBrutes])
plot(temps,[(s_filtree - modele)./s_filtree])
title("erreur relative  (s_filtrée - modèle)/s_filtrée")
 xlabel("temps")
ylabel("erreur relative")
